C              INPUT DATA SYNTHESIZING 
C       FOR THREE DIMENSIONAL ELASTIC ANALYSIS
C          ----- F3DSY.FOR (1997/7) -----
C                 BY TAKAYUKI HIRAI
C
      COMMON BA(60000),PRB(500),EMB(500),EMA(500),PRA(500),
     1       MVA(8000),IB(8000),BB(24000),NCA(40000),
     2       NCB(40000),MVB(8000)
      CHARACTER TITLEA*40,TITLEB*40
C
C  ------------------  INPUT DATA  --------------------
      KNELE=2000
      KNODE=8000
      KNMAT=500
      IRR=0
      OPEN(15,FILE='DA',STATUS='OLD')
      OPEN(25,FILE='DB',STATUS='OLD')
      OPEN(16,FILE='DD')
      CLOSE(16,STATUS='DELETE')
      OPEN(16,FILE='DD')                                        
      READ(15,1001) TITLEA 
      WRITE(*,2001) TITLEA
      READ(15,1002) NELEA,NODEA,NMATA,NGAA
      IF(NELEA*(KNELE-NELEA+1).LE.0) IRR=11000
      IF(NODEA*(KNODE-NODEA+1).LE.0) IRR=12000
      IF(NMATA*(KNMAT-NMATA+1).LE.0) IRR=13000
      IF((NGAA-2)*(6-NGAA).LE.0.0) IRR=14000
      IF(IRR.NE.0) GO TO 403
      NODEA3=3*NODEA
      DO 10 I=1,NODEA 
   10 READ(15,1003) NS,BA(I*3-2),BA(I*3-1),BA(I*3)
      DO 15 J=1,NELEA
      READ(15,1005) MS,(NCA(I+J*20-20),I=1,20),MVA(J),S6
      DO 19 I=1,20 
      IF(I.EQ.20) GO TO 19
      I3=I+1
      DO 14 K=I3,20
   14 IF(NCA(I+J*20-20).EQ.NCA(K+J*20-20)) IRR=20000+J
   19 IF(NCA(I+J*20-20)*(NODEA-NCA(I+J*20-20)+1).LE.0)
     1    IRR=30000+J
   15 IF(MVA(J)*(NMATA-MVA(J)+1).LE.0) IRR=35000+J
      IF(IRR.NE.0) GO TO 403
      DO 16 J=1,NMATA
      READ(15,1006) ID,EMA(J),PRA(J)
      IF(EMA(J).LE.1.0) IRR=50000+J
      IF(PRA(J)*(0.4999-PRA(J)).LT.0) IRR=55000+J
   16 IF(IRR.NE.0) GO TO 403
      CLOSE(15,STATUS='KEEP')
      READ(25,1001) TITLEB 
      WRITE(*,2041) TITLEB
      READ(25,1002) NELEB,NODEB,NMATB,NGAB
      IF(NELEB*(KNELE-NELEB+1).LE.0) IRR=11000
      IF(NODEB*(KNODE-NODEB+1).LE.0) IRR=12000
      IF(NMATB*(KNMAT-NMATB+1).LE.0) IRR=13000
      IF((NGAB-2)*(6-NGAB).LE.0.0) IRR=14000
      IF(IRR.NE.0) GO TO 403
      NODEB3=3*NODEB
      DO 20 I=1,NODEB 
   20 READ(25,1003) NS,BB(I*3-2),BB(I*3-1),BB(I*3) 
      DO 25 J=1,NELEB
      READ(25,1005) MS,(NCB(I+J*20-20),I=1,20),MVB(J),S6
      DO 29 I=1,20 
      IF(I.EQ.20) GO TO 29
      I3=I+1
      DO 24 K=I3,20
   24 IF(NCB(I+J*20-20).EQ.NCB(K+J*20-20)) IRR=20000+J
   29 IF(NCB(I+J*20-20)*(NODEB-NCB(I+J*20-20)+1).LE.0)
     1    IRR=30000+J
   25 IF(MVB(J)*(NMATB-MVB(J)+1).LE.0) IRR=35000+J
      IF(IRR.NE.0) GO TO 403
      DO 26 J=1,NMATB
      READ(25,1006) ID,EMB(J),PRB(J)
      IF(EMB(J).LE.1.0) IRR=50000+J
      IF(PRB(J)*(0.4999-PRB(J)).LT.0) IRR=55000+J
   26 IF(IRR.NE.0) GO TO 403
      CLOSE(25,STATUS='KEEP')
 1001 FORMAT(A40) 
 1002 FORMAT(4I5)
 1003 FORMAT(I5,3F15.6)
 1004 FORMAT(4I5,3E15.6)
 1005 FORMAT(11I4/I8,10I4,F10.7)
 1006 FORMAT(I5,2F15.6)
 2001 FORMAT(/'           START     TITLEA = ',A40)
 2041 FORMAT('           START     TITLEB = ',A40)
C
C   ----------- SYNTHESIZING DATA -----------
      I4=NODEA
      DO 101 J=1,NODEB
      DO 108 I=1,NODEA
      IF(ABS(BA(I*3-2)-BB(J*3-2)).GT.0.00001) GO TO 108
      IF(ABS(BA(I*3-1)-BB(J*3-1)).GT.0.00001) GO TO 108
      IF(ABS(BA(I*3)-BB(J*3)).GT.0.00001) GO TO 108
      IB(J)=I
      GO TO 101
  108 CONTINUE
      I4=I4+1
      IB(J)=I4
      BA(I4*3-2)=BB(J*3-2)
      BA(I4*3-1)=BB(J*3-1)
      BA(I4*3)=BB(J*3)
  101 CONTINUE
      DO 211 I=1,NELEB
      DO 212 J=1,20
  212 NCA((I+NELEA)*20-20+J)=IB(NCB(I*20-20+J))
  211 MVA(I+NELEA)=MVB(I)+NMATA
      DO 231 I=1,NMATB
      EMA(NMATA+I)=EMB(I)
  231 PRA(NMATA+I)=PRB(I)
      NELE=NELEA+NELEB
      NMAT=NMATA+NMATB
      WRITE(16,1001) TITLEA 
      WRITE(16,1002) NELE,I4,NMAT,3
      DO 301 I=1,I4 
  301 WRITE(16,1003) I,BA(I*3-2),BA(I*3-1),BA(I*3)
      DO 302 I=1,NELE
  302 WRITE(16,1005) I,(NCA(J+I*20-20),J=1,20),MVA(I),0.0
      DO 304 I=1,NMAT
  304 WRITE(16,1006) I,EMA(I),PRA(I)
      WRITE(16,2027)
      WRITE(16,2028)
      WRITE(16,2029)
      WRITE(16,2030)
  403 IF(IRR.EQ.0) WRITE(*,2055) 
      IF(IRR.EQ.0) GOTO 450
      WRITE(*,2056) IRR
      WRITE(16,2056) IRR
      WRITE(*,3003) 
      READ(*,*) TITLEB
 3003 FORMAT(//'  PUSH  Y  AND  ENTER  KEY ')
 2027 FORMAT('    1    1    1    1       0.000000'
     1    ,'       0.000000       0.000000')
 2028 FORMAT('    2    1    1    1       0.000000'
     1    ,'       0.000000       0.000000')
 2029 FORMAT('    3    1    1    1       0.000000'
     1    ,'       0.000000       0.000000')
 2030 FORMAT('99999')
 2055 FORMAT('      ----- DATA IS SYNTHESIZED -----')
 2056 FORMAT('      ----- DATA ERROR -----   IRR =',I6)
  450 CLOSE(16,STATUS='KEEP')
      CLOSE(15,STATUS='KEEP')
      CLOSE(25,STATUS='KEEP')
      STOP
      END
